package HSPC::Console;

use strict;
use SWsoft::protect;	# Mark this module for encryption upon build

use HSPC::Config;
use HSPC::ErrorStack;
use HSPC::ConsoleSecurity;

use HSPC::MT::BM;
use HSPC::MT::Core;

use base 'HSPC::System';

my $console = new HSPC::Console
	unless $ENV{MOD_PERL} || ref($ENV{system_obj});
HSPC::MT::BM->core_init();

sub new {
	# init dimmy security object #
	$ENV{security_obj} = HSPC::ConsoleSecurity->factory();

	# init error object #
	$ENV{error_obj} = new HSPC::ErrorStack();

	shift->SUPER::new(@_);
}

sub is_console{ 1 }

1;
