## root class of hspc exceptions
package HSPC::Exc::Mutex;
use strict;
use SWsoft::protect;

use HSPC::Trace;
use HSPC::Exc;

use vars qw{@ISA};
@ISA = qw{HSPC::Exc};

## constructor
sub new {
    my $class = shift;
	my %h = (
		mutex   => undef,
		timeout => undef,
		@_
	);
    my $self = $class->SUPER::new(%h);

	$self->{'mutex'}   = $h{'mutex'};
	$self->{'timeout'} = $h{'timeout'};

    return $self;
};

## accessors.
sub mutex   { my $self = shift; return $self->{'mutex'};   }
sub timeout { my $self = shift; return $self->{'timeout'}; }

## if somebody try to use $@ as string it returns what this function returns.
sub stringify {
    my $self = shift;
	my $str;
	if ($self->timeout > 0) {
		$str = "Can't obtain mutex '".$self->mutex."' during timeout ".$self->timeout." seconds";
	} else {
		$str = "Can't obtain mutex '".$self->mutex."' immidiately";
	}
    return $str;
};

1;
