package HSPC::MT::AbstractListItem;

use strict;

##--------------------------------------------------
## Inheritance
##-------------------------------------------------- 
use HSPC::MT::Abstract;
use vars qw{ @ISA };
@ISA = qw{ HSPC::MT::Abstract };

##--------------------------------------------------
## Redefinition of new, which automatically fill all keys by given values
##-------------------------------------------------- 
sub new {
	my $class = shift;
	my %h     = (@_);

	my $self = $class->SUPER::new(%h);

	while ( my ( $key, $value ) = each(%h) ) {
		$self->{$key} = $value;
	}

	return $self;
}

sub save {
	sw_die("not designed for direct save");
}

sub load {
	sw_die("not designed for direct load");
}

sub delete {
	sw_die("not designed for direct delete");
}

1;
