package HSPC::MT::Entity;
## TODO : drop this module, use HSPC::MT::Core::* from hspc-core package

use strict;

use HSPC::Localization qw(:DEFAULT string string_lang);
use HSPC::WebDB;
use HSPC::MT::Address;
use HSPC::MT::Person;
use HSPC::MT::Person::Role;
use SWsoft::protect;	# Mark this module for encryption upon build
use SWsoft::HSPC::License;

use HSPC::Logger qw(sw_die);
use HSPC::WebSystemLib;



## > class
## >= account_type
## < info{total_accounts=>,active_accounts=>,total_accounts=>}
sub load_accounts_info {
	my $class=shift;
	my %h=(@_);
	my $info;

	my $w=' AND account_type='.$h{account_type} if $h{account_type};
	$w.=' AND vendor='.$ENV{security_obj}->account_no if $ENV{security_obj}->account_type>0;

	$info->{active_accounts} = HSPC::WebDB::select_result(q{SELECT COUNT(*) FROM account WHERE status=0 }.$w);
	$info->{onhold_accounts} = HSPC::WebDB::select_result(q{SELECT COUNT(*) FROM account WHERE status=1 }.$w);
	$info->{total_accounts} = $info->{active_accounts} + $info->{onhold_accounts};

	return $info
}

sub load {
	my $self = shift;
	my $address_id;

	my $account = HSPC::WebDB::select_hash( 'select * from account where account_no = ?', $self->{account_no} );

	my $address = HSPC::MT::Address::get_address($account->{address_id}) if defined $account->{address_id};

	map { $self->{$_} = $account->{$_} } keys %$account;
	map { $self->{$_} = $address->{$_} } keys %$address;
	$self->{bill_checkbox} = 1 if $self->{billing_email}   eq $self->{admin_email};
	$self->{tech_checkbox} = 1 if $self->{technical_email} eq $self->{admin_email};
}

sub update_contact_info {
	my $self = shift;

 HSPC::WebDB::select_run(q{update account
		set admin_prefix=?, admin_fname=?, admin_mname=?, admin_lname=?, admin_suffix=?, admin_email=?, admin_phone=?,
		billing_prefix=?, billing_fname=?, billing_mname=?, billing_lname=?, billing_suffix=?, billing_email=?, billing_phone=?,
		technical_prefix=?, technical_fname=?, technical_mname=?, technical_lname=?, technical_suffix=?, technical_email=?, technical_phone=?
		where account_no=?},
		$self->{admin_prefix}, $self->{admin_fname}, $self->{admin_mname}, $self->{admin_lname}, $self->{admin_suffix}, $self->{admin_email}, $self->{admin_phone},
		$self->{billing_prefix}, $self->{billing_fname}, $self->{billing_mname}, $self->{billing_lname}, $self->{billing_suffix}, $self->{billing_email}, $self->{billing_phone},
		$self->{technical_prefix}, $self->{technical_fname}, $self->{technical_mname}, $self->{technical_lname}, $self->{technical_suffix}, $self->{technical_email}, $self->{technical_phone},
		$self->{account_no}
		);
}

sub update_contact_person {
	my $self = shift;

 HSPC::WebDB::select_run(q{update account
		set admin_prefix=?, admin_fname=?, admin_mname=?, admin_lname=?, admin_suffix=?, admin_email=?, admin_phone=?,
		billing_prefix=?, billing_fname=?, billing_mname=?, billing_lname=?, billing_suffix=?, billing_email=?, billing_phone=?,
		technical_prefix=?, technical_fname=?, technical_mname=?, technical_lname=?, technical_suffix=?, technical_email=?, technical_phone=?
		where account_no=?},
		$self->{admin_prefix}, $self->{admin_fname}, $self->{admin_mname}, $self->{admin_lname}, $self->{admin_suffix}, $self->{admin_email}, $self->{admin_phone},
		$self->{admin_prefix}, $self->{admin_fname}, $self->{admin_mname}, $self->{admin_lname}, $self->{admin_suffix}, $self->{admin_email}, $self->{admin_phone},
		$self->{admin_prefix}, $self->{admin_fname}, $self->{admin_mname}, $self->{admin_lname}, $self->{admin_suffix}, $self->{admin_email}, $self->{admin_phone},
		$self->{account_no}
		);
}

sub insert_default_admin {
	my $self = shift;

	my $count_person = HSPC::MT::Person->check_count($self->{admin_email});
	my $id_admin;
	my $address_id;
	if ($count_person == 0){
		# there was code using WebDB with auth_asppassport table
		sw_die("Things are going really wrong. Ask baza@ or dkoles@ fro info");
	}else{
		my $person = HSPC::MT::Person->get_person_by_mail($self->{admin_email});
		$id_admin = $person->{person_id};
	}
	#### add contact persons to account
 HSPC::WebDB::select_run(q{INSERT INTO person_account (account_no, person_id, status) VALUES (?,?,?)},$self->{account_no},$id_admin, 0);
	####
	#### add role to contact persons
	my $role_id;
	$role_id = 6 if $self->{account_type} == 2;
	$role_id = 9 if $self->{account_type} == 3;
	HSPC::MT::Person::Role::insert($self->{account_no},$id_admin, $role_id);
	####
}

sub delete {
	my $self = shift;

	HSPC::WebDB::select_run(q{update account set status = 255 where account_no = ?},$self->{account_no});
}


## => email
## => vendor
## <= array account_no
sub check_account {
	# there was code using WebDB with auth_asppassport table
	sw_die("Things are going really wrong. Ask baza@ or dkoles@ fro info");
}

## > class
## > browse_info : {}
## < list
sub get_web_pages {
	my $class = shift;
	my $info = shift;
	my $security = $ENV{security_obj};
	my $where='';
	$where = ' and a.account_type='.$class->{account_type} if $class->{account_type};
	$where.=' and a.vendor='.$security->account_no if $security->account_type>0;
	my $join_sql = ' left join account v on a.vendor = v.account_no  ';

	HSPC::WebDB::select_data(
		request		=>	$info,
		tables		=>	'account a'.$join_sql,
		gate_cols	=>	{
				id		=>	'a.account_no',
				title		=>	'a.name',
				person_name	=>	'concat(a.admin_prefix," ",a.admin_fname," ",a.admin_mname," ",a.admin_lname," ",a.admin_suffix)',
				vendor		=>	'v.name',
				status		=>	'a.status',
				type		=>	'a.account_type',
				state		=>	1
			},
		where		=>	'a.status!=255'.$where
		);
}


## > class
## > browse_info : {}
## < list
sub get_browse_entity {
	my %args = (
		info => undef,
		account_type => undef, ## numeric | ref
		vendor => undef,
		where => undef,	## string start with ' and ' Example: where => ' and qqq=eee'
	,@_);

	my $where='';
	my $security = $ENV{security_obj};
	$args{vendor} = $security->account_no if $security->account_type>0;

	if ($args{account_type}) {
		my $values = ref($args{account_type}) eq 'ARRAY'?$args{account_type}:[$args{account_type}];
		$where.=' and ( ';
		my $index=0;
		foreach my $value(@$values){
			$where .= q{ OR } if $index>0;
			$where .= ' a.account_type = '.quote($value);
			$index++;
		}
		$where .= ' ) ';
	}
	$where.=' and a.vendor='.$args{vendor} if $args{vendor};
	$where .= $args{where} if ($args{where});

	HSPC::WebDB::select_data(
		request		=>	$args{info},
		tables		=>	'account a left join account v on a.vendor = v.account_no ',
		gate_cols	=>	{
				aid		=>	'a.account_no',
				title		=>	'a.name',
				person_name	=>	'concat(a.admin_prefix," ",a.admin_fname," ",a.admin_mname," ",a.admin_lname," ",a.admin_suffix)',
				vendor		=>	'v.name',
				vendor_id  	=>	'a.vendor',
				vendor_type	=>	'v.account_type',
				status		=>	'a.status',
				type		=>	'a.account_type',
				state		=>	1
			},
		where		=>	'a.status!=255'.$where
		);
}


## > class
## > browse_info : {}
## < list
sub get_resellers_customer {
	my $class = shift;
	my $info = shift;

	my $search = sw_uriparam('title_f');
	$search = sw_argparam('title_f') unless ($search);
	my $where;

	$where = 'a.status!=255 and a.account_type=3 and a.vendor='.$class->{account_no};
	if ($search){
		my $str = $search;
		$str=~ s| +||sg;
		$where .= ' and ((a.name like \'%'.$search.'%\') or (upper(CONCAT(a.admin_fname, a.admin_mname, a.admin_lname)) like \'%'.$str.'%\'))';
	}
 HSPC::WebDB::select_data(tables=>'account a ', where=>$where, gate_cols=>{rc_id=>'a.account_no',title=>'a.name', person_name=>'concat(a.admin_prefix," ",a.admin_fname," ",a.admin_mname," ",a.admin_lname," ",a.admin_suffix)', status=>'a.status',type=>'a.account_type',state=>1},request=>$info);
}


sub get_account_type {
	my $class = shift;
	my $account_no = shift;

	my $result =HSPC::WebDB::select_result(q{SELECT account_type from account where account_no=?},$account_no);
	return $result;
}

sub get_account_type_text {
	my $class = shift;
	my $account_type = shift;

	my %account_type_text=(
	'2'=>string('reseller'),
	'3'=>string('accnt_uc'),
	);

	return $account_type_text{$account_type};
}


sub get_account {
	my $class = shift;
	my $account_no = shift;

	my $data = HSPC::WebDB::select_hash(q{SELECT * FROM account WHERE account_no=?},$account_no);

	return $data;
}


sub get_account_roles {
	my $account_no = shift;
	my $no_admins = shift;
	my $res = HSPC::WebDB::select_rows(q{SELECT r.role_id, r.name from role r, account a
		where r.account_type=a.account_type
		and a.account_no=?},$account_no);
	if ($account_no == 1 && $no_admins) {
		## Exclude HSP Administartors from the list of available roles
		my @t = grep{$_->[0] > 2} @$res;
		return \@t;
	}
	else {
		$res;
	}
}

## Returns list of persons accounts
## Arguments:
##   person_id
sub get_all_accounts {
	my ($class, $info) = @_;

	my $so = $ENV{security_obj};
	return unless $so && $so->{account_type} <= 2;	# Not for Customers

	my $scope_constraint = '';

	$so->{account_type} == 0 or do {
		my $this_account_no = HSPC::WebDB::quote($so->{account_no});
		$scope_constraint = qq { AND ( vendor = $this_account_no OR account_no = $this_account_no ) };
	};

 HSPC::WebDB::select_data (
		request		=> $info,
		tables		=>  'account',
		gate_cols	=> {
			a			=> 'account_no',
			name		=> 'name',
			type		=> 'account_type'
		},
		where		=> qq { status != 255 $scope_constraint },
		debug		=> 0
	);
}

1;

__END__
