package HSPC::Startup;

use SWsoft::protect; # Mark this module for encryption upon build

use utf8;
use Apache::DBI;


BEGIN {

## check DB connection
require HSPC::Application;
my $dbh = HSPC::Application->db_connection();
die $@ unless ref($dbh) =~ /DBI/ && $dbh->ping;

{ ## Chek upgrade status
	my $sth = $dbh->prepare("select count(*) from version where factory != 'common' AND finished != 2");
	$sth->execute();
	my $rows = $sth->fetchall_arrayref();
	$sth->finish();
	die "\nSystem upgrade has not been completed!\nPlease continue upgrade process by using 'hspc-upgrade-manager --finish' command\n\n"
		if $rows->[0]->[0];
}

if (getpgrp(0) == $$) {

require Apache::Constants;
sub Startup::Fix_env($) {
	my $r = shift;

	# rewrite hostname (set ENV{'SERVER_NAME'})
	return Apache::Constants::OK
		unless $r->header_in('X-Forwarded-Host');

	if ($r->headers_in->{'X-Forwarded-Host'} =~ /^([^,\s]+)/){
		my $host = $1;
		my $maxtr = 100;
		## try to set hostname (via mod_perl 1 getter method)
		$r->hostname($host) while $r->hostname ne $host && --$maxtr;
	}

	# rewrite REMOTE_ADDR
	return Apache::Constants::OK
		unless $r->header_in('X-Forwarded-For');

	$r->connection->remote_ip($1)
		if $r->headers_in->{'X-Forwarded-For'} =~ /^([^,\s]+)/;

    return Apache::Constants::OK;
}

## Apache/CGI modules
require Apache;
require Apache::Registry;
require CGI;
require CGI::Cookie;
require CGI::Util;

## Perl librariers
require Config::General;
require Digest::MD5;
require Digest::SHA;
require Fcntl;
require IO::Socket;
require POSIX;

## Third party modules
require Text::Template;

require XML::Parser;
require XML::Simple;
$XML::Simple::PREFERRED_PARSER = 'XML::Parser';

## HSPC modules
require HSPC::MT::ODB::ClassManager;
require HSPC::MT::Abstract;
require HSPC::MT::LangValue;
require HSPC::AbstractDashboard;

require HSPC::CompRep;
require HSPC::Request;

require HSPC::Util;
require HSPC::Config;
require HSPC::DataRequest;
require HSPC::ErrorCodes;
require HSPC::GeoData;
require HSPC::LM::AP::HN;
require HSPC::LM::AP;
require HSPC::LM::Common;
require HSPC::LM::Dashboard;
require HSPC::LM::MN::Usage;
require HSPC::LM::MN;
require HSPC::LM::VZ::DataProvider;
require HSPC::LM::VZDashboard;
require HSPC::Localization;
require HSPC::Logger;
require HSPC::SM::Dashboard;
require HSPC::SM::Staff;
require HSPC::SM::User;
require HSPC::Session;
require HSPC::WebDB;
require HSPC::WebElements;
require HSPC::WebJS;
require HSPC::WebPage;
require HSPC::AM::CCAccounts;
require HSPC::AM::CCAccountsNew;
require HSPC::Action;
require HSPC::ActionErrors;
require HSPC::Billing::Core::DocType;
require HSPC::Billing::Ar_account;
require HSPC::Billing::Terms;
require HSPC::Billing::Ar_doc;
require HSPC::Billing::Ar_statement;
require HSPC::Billing::Discount_category;
require HSPC::Billing::Hash;
require HSPC::Billing::Reports;
require HSPC::Billing::Def_price;
require HSPC::Billing::SSUI;
require HSPC::Billing::Setup;
require HSPC::Billing::Subscription;

require HSPC::MT::Billing::PromoApp;
require HSPC::MT::Billing::Promotion;
require HSPC::MT::Billing::PromoFactory;
require HSPC::MT::Billing::PromoComponent;

require HSPC::MT::Billing::PriceTools;
require HSPC::MT::BM::Price;
require HSPC::CC::BackupAction;
require HSPC::CC::Core;
require HSPC::CC::Dashboards;
require HSPC::CC::Front;
require HSPC::CC::Person;
require HSPC::CCP::Plugin;
require HSPC::CCP::TransLog;
require HSPC::CM::CC;
require HSPC::CM::CCHider;
require HSPC::CM::CCRequests;
require HSPC::CM::CCResellers;
require HSPC::CM::CCResellersNew;
require HSPC::CM::CCTerms;
require HSPC::CU::Skin::Image;
require HSPC::CU::Skin::TreeDemo;
require HSPC::CU::Skin;
require HSPC::Core::CoreUI;
require HSPC::Core::WebHelp;
require HSPC::MT::Core::MailView;
require HSPC::DM::Plugin::Config;
require HSPC::DataCheck;
require HSPC::EM::CCDashboard;
require HSPC::EM::CCStoreRefs;
require HSPC::EM::HPDHOrder;
require HSPC::EM::HPDMOrder;
require HSPC::EM::HPOrder;
require HSPC::EM::HPVEOrder;
require HSPC::EM::HPVEVHOrder;
require HSPC::EM::Office::GenSetup;
require HSPC::EM::Office::Plans;
require HSPC::EM::Office::Plugin;
require HSPC::EM::Office;
require HSPC::EM::Order;
require HSPC::EM::Plugins::AbstractPlugin;
require HSPC::EM::Plugins::Offline_Check;
require HSPC::EM::Plugins::Offline_Phone;
require HSPC::EM::Plugins::Offline_TT;
require HSPC::EM;
require HSPC::EV::Setup;
require HSPC::EV::Actions;
require HSPC::Error;
require HSPC::ErrorStack;
require HSPC::GM::CCInterface;
require HSPC::GM::CCLocale;
require HSPC::GM::CCMail;
require HSPC::GM::CCStat;
require HSPC::GM::SSL;
require HSPC::GM::Setup;
require HSPC::IM::Exclusion;
require HSPC::IM::IPPoolSetup;
require HSPC::IM::IPPopup;
require HSPC::IM::Leases;
require HSPC::IM::PoolLeases;
require HSPC::Core::EMail;
require HSPC::MM::CC;
require HSPC::MM::CCCampaigns;
require HSPC::MM::CCReport;
require HSPC::MT::AD::Application;
require HSPC::MT::AD::Installation;
require HSPC::MT::AD::OSTemplate;
require HSPC::MT::AD::Setup;
require HSPC::MT::AD::Template;
require HSPC::MT::AD;
require HSPC::MT::AgentBM;
require HSPC::MT::Core::Sequence;
require HSPC::MT::Billing::Acc_balance;
require HSPC::MT::Billing::Acc_transaction;
require HSPC::MT::Billing::App_fees;
require HSPC::MT::Billing::Ar_account;
require HSPC::MT::Billing::Ar_doc;
require HSPC::MT::BM::DocDet;
require HSPC::MT::Billing::Ar_doc_paymethod;
require HSPC::MT::Billing::Ar_doc_status;
require HSPC::MT::Billing::Ar_statement;
require HSPC::MT::Billing::Bill;
require HSPC::MT::Billing::CreditAdjustment;
require HSPC::MT::Billing::DebitAdjustment;
require HSPC::MT::Billing::DiscountCategory;
require HSPC::MT::Billing::Order;
require HSPC::MT::Billing::Batch;
require HSPC::MT::Billing::BatchTools;
require HSPC::MT::BM::Batch_status;
require HSPC::MT::Billing::SellablePeriod;
require HSPC::MT::Billing::Datecalc;
require HSPC::MT::BM::HP;
require HSPC::MT::BM::HP::PleskDomain;
require HSPC::MT::BM::HP::PleskServer;
require HSPC::MT::BM::HP::PleskClient;
require HSPC::BM::HP::Tab::Manager;
require HSPC::BM::HP::Edit::Abstract;
require HSPC::MT::BM::Order::PleskDomain;
require HSPC::MT::BM::Order::PleskServer;
require HSPC::MT::Billing::OrderBill;
require HSPC::MT::Billing::Order_hw_vz;
require HSPC::MT::Billing::Order_hw_generic;
require HSPC::MT::Billing::Order_domain;
require HSPC::MT::Billing::Order_hw;
require HSPC::MT::Billing::Order_ve;
require HSPC::MT::Billing::OrderedDomain;
require HSPC::MT::Billing::Order_onetime;
require HSPC::MT::Billing::Order_misc;
require HSPC::MT::Billing::Payment;
require HSPC::MT::Billing::OnLinePayment;
require HSPC::MT::Billing::OffLinePayment;
require HSPC::MT::Billing::Reports;
require HSPC::MT::Billing::NRes::Generic;
require HSPC::MT::Billing::NRes::Item;
require HSPC::MT::Billing::NRes::SubscrItem;
require HSPC::MT::Billing::NRes::OrderItem;
require HSPC::MT::Billing::NRes::HP;
require HSPC::MT::Billing::Subscription;
require HSPC::MT::Billing::Subscription_base;
require HSPC::MT::Billing::Subscription_hw_vz;
require HSPC::MT::Billing::Subscription_hw_generic;
require HSPC::MT::Billing::Subscription_domain;
require HSPC::MT::Billing::Subscription_hw;
require HSPC::MT::Billing::Subscription_ve;
require HSPC::MT::BM::Subscr_status;
require HSPC::MT::Billing::Subscr_hp;
require HSPC::MT::Billing;
require HSPC::MT::Billing::CurrencyTools;
require HSPC::MT::CM::Hider;
require HSPC::MT::CU::Component;
require HSPC::MT::CU::ComponentContent;
require HSPC::MT::CU::File;
require HSPC::MT::CU::Installer;
require HSPC::MT::CU::Layout;
require HSPC::MT::CU::SkinPalette;
require HSPC::MT::CU::SkinImage;
require HSPC::MT::CU::SkinImageType;
require HSPC::MT::CU::Skin;
require HSPC::MT::CU::Tool;
require HSPC::MT::CU;
require HSPC::MT::Core::AbstractAccount;
require HSPC::MT::Core::AbstractProvider;
require HSPC::MT::Core::AbstractSetup;
require HSPC::MT::Core::Address;
require HSPC::MT::Core::Customer;
require HSPC::MT::Core::HSP;
require HSPC::MT::Core::Person;
require HSPC::MT::Core::PersonAccount;
require HSPC::MT::Core::PrintForm;
require HSPC::GM::PrintFormNew;
require HSPC::MT::Core::Reseller;
require HSPC::MT::Core::Role;
require HSPC::MT::Core::Service::Account;
require HSPC::MT::Core::PluginFactory;

require HSPC::MT::Core::ExtAttrType;
require HSPC::MT::Core::ExtAttr;
require HSPC::MT::Core::ExtAttrCollection;
require HSPC::MT::Core::ExtAttrFactory;
require HSPC::MT::Core::ExtAttrIterator;
require HSPC::MT::Core::ExtAttrVerificator;
require HSPC::Core::ExtAttrUI;

require HSPC::Core::Type::Abstract;
require HSPC::Core::Type::AbstractBase;
require HSPC::Core::Type::Bool;
require HSPC::Core::Type::Int;
require HSPC::Core::Type::String;
require HSPC::CM::ResellerConfig;
require HSPC::MT::CM::ResellerConfig;


require HSPC::MT::Core;
require HSPC::MT::DM::Domain;
require HSPC::MT::DM::DomainRegistration;
require HSPC::MT::DM::Plugin::Abstract;
require HSPC::MT::DM::Plugin::Config;
require HSPC::MT::DM::RegEngine;
require HSPC::MT::EM::Installer;
require HSPC::MT::EM::Plugin;
require HSPC::MT::EM::Plugins::AbstractPlugin;
require HSPC::MT::EM::Plugins::Offline_Check;
require HSPC::MT::EM::Plugins::Offline_Phone;
require HSPC::MT::EM::Plugins::Offline_TT;
require HSPC::MT::EM::Store;
require HSPC::MT::EM;
require HSPC::MT::EV::Event_setup;
require HSPC::MT::EV::Event_type;
require HSPC::MT::EV::Hash;
require HSPC::MT::EV::ActionItem;
require HSPC::MT::GM::CompanyProfile;
require HSPC::MT::GM::ProviderConfig;
require HSPC::MT::GM::SSL;
require HSPC::MT::GM::Stat;
require HSPC::MT::GM;
require HSPC::MT::IM::VPSIPView;
require HSPC::MT::IM::Exclusion;
require HSPC::MT::IM::IP;
require HSPC::MT::IM::IPAddress;
require HSPC::MT::IM::IPPool;
require HSPC::MT::IM::Setup;
require HSPC::MT::IM;
require HSPC::MT::OM::Action;
require HSPC::MT::OM::Conflict;
require HSPC::MT::OM::Constants;
require HSPC::MT::OM::HN;
require HSPC::MT::OM::Rack;
require HSPC::MT::OM::Resource;
require HSPC::MT::OM::VE;
require HSPC::MT::OM;
require HSPC::MT::OM::BackupStorage;
require HSPC::MT::PM::Installer;
require HSPC::MT::PM::MenuStyle;
require HSPC::MT::PM::Plugin;
require HSPC::MT::PM::Plugins::PageAbout;
require HSPC::MT::PM::Plugins::PageContact;
require HSPC::MT::PM::Plugins::PageFAQ;
require HSPC::MT::PM::Plugins::PageHome;
require HSPC::MT::PM::Plugins::PagePartners;
require HSPC::MT::PM::Plugins::PageSupport;
require HSPC::MT::PM::Site;
require HSPC::MT::PM::SiteFile;
require HSPC::MT::PM::SiteMenu;
require HSPC::MT::PM::SiteMenuItem;
require HSPC::MT::PM::SitePage;
require HSPC::MT::PM;
require HSPC::MT::SB;
require HSPC::MT::SM;
require HSPC::MT::SiteLayout;
require HSPC::Mailer;
require HSPC::OM::ActionLog;
require HSPC::OM::Common;
require HSPC::OM::DataCenter;
require HSPC::OM::HNPopup;
require HSPC::OM::HNSetup;
require HSPC::OM::Setup;
require HSPC::OM::UI;
require HSPC::OM::VESetup;
require HSPC::OnDemand;
require HSPC::PM::CC;
require HSPC::PM::CCFiles;
require HSPC::PM::CCMenus;
require HSPC::PM::CCPages;
require HSPC::PM::CCPagesPreview;
require HSPC::PM::CCSettings;
require HSPC::PM::Plugins::PageAbout;
require HSPC::PM::Plugins::PageContact;
require HSPC::PM::Plugins::PageFAQ;
require HSPC::PM::Plugins::PageHome;
require HSPC::PM::Plugins::PagePartners;
require HSPC::PM::Plugins::PageSupport;
require HSPC::PM;
require HSPC::SB::Nodes;
require HSPC::SB::Plans;
require HSPC::SB::Sites;
require HSPC::SB::Setup;
require HSPC::SL::Constant;
require HSPC::SL::Manager;
require HSPC::SL::RepLimitApproach;
require HSPC::SL::Webstat;
require HSPC::SM::AuthAbstract;
require HSPC::SM::AuthLocalHSPC;
require HSPC::SM::CCPermissions;
require HSPC::SM::CCUsers;
require HSPC::SM::CoreUI;
require HSPC::Security;
require HSPC::Site::ComponentContent;
require HSPC::Site::Layout;
require HSPC::Site::Office;
require HSPC::Exc;
require HSPC::Exc::Fatal;
require HSPC::Exc::Mysql;
require HSPC::Exc::Mutex;
require HSPC::System;
require HSPC::String;
require HSPC::SystemSetting;
require HSPC::Trace;
require HSPC::Mutex;
require HSPC::MutexName;
require HSPC::Transaction;
require HSPC::TaskExec;
require HSPC::Taskman;
require HSPC::UISteps;
require HSPC::UIStepsPage;
require HSPC::UIStepsSession;
require HSPC::UM::Core::CC;
require HSPC::UM::Core::CCProblem;
require HSPC::UM::TS::CC;
require HSPC::UM::TS::CCSetup;
require HSPC::UM::TS;
require HSPC::WebGrid;
require HSPC::WebSecurity;
require HSPC::WebSystem;
require HSPC::WebSystemLib;

## CC Menu
require HSPC::MenuTree;
require HSPC::CC::Menu::Tree;
require HSPC::MT::CC::MenuCreator;
require HSPC::AD::Menu;
require HSPC::AM::Menu;
require HSPC::CC::Menu;
require HSPC::CM::Menu;
require HSPC::CU::Menu;
require HSPC::DM::Menu;
require HSPC::EM::Menu;
require HSPC::EV::Menu;
require HSPC::GM::Menu;
require HSPC::IM::Menu;
require HSPC::LM::Menu;
require HSPC::MM::Menu;
require HSPC::PM::Menu;
require HSPC::SL::Menu;
require HSPC::SM::Menu;

## CP core modules
require HSPC::CP::AbstractApp;
require HSPC::CP::Menu;
require HSPC::CP::Util;
require HSPC::CP::Visual;
require HSPC::CP;
require HSPC::MT::CP::DashCreator;
require HSPC::MT::CP::MenuCreator;
require HSPC::MT::CP::SummaryCreator;

## MyCP
require HSPC::MyCP::FM;
require HSPC::MyCP::Mail;
require HSPC::MyCP::User;
require HSPC::MyCP;

## CP Menu
require HSPC::CP::Menu::Person;
require HSPC::CP::Menu::Account;

## CP Person
require HSPC::CP::Person;
require HSPC::CP::Person::Profile;
require HSPC::CP::Person::Settings;

## CP account
require HSPC::CP::Account::Main;
require HSPC::CP::Account::Document;
require HSPC::CP::Account::PayOrder;
require HSPC::CP::Account::Statement;
require HSPC::CP::Account::Subscription;
require HSPC::CP::Selector::Account;

## CP System/Site modules
require HSPC::CP::Application;
require HSPC::CP::Backup;
require HSPC::CP::Crontab;
require HSPC::CP::DNS;
require HSPC::CP::FM;
require HSPC::CP::FTPAccount;
require HSPC::CP::FrontPage;
require HSPC::CP::MySQL;
require HSPC::CP::MySQLError;
require HSPC::CP::PHPMyAdmin;
require HSPC::CP::ResUsage;
require HSPC::CP::Selector::Site;
require HSPC::CP::Selector::System;
require HSPC::CP::Sendmail;
require HSPC::CP::Server;
require HSPC::CP::System::Apache;
require HSPC::CP::System::FM;
require HSPC::CP::System::ProFTPD;
require HSPC::CP::System;
require HSPC::CP::TS;
require HSPC::CP::UGM;
require HSPC::CP::VEServices;
require HSPC::CP::Website::FM;
require HSPC::CP::Website;
require HSPC::CP::WebsiteStats;

## CP dynamic Menu/Dash modules
require HSPC::CP::Menu::Account;
require HSPC::CP::Menu::Apache;
require HSPC::CP::Menu::Application;
require HSPC::CP::Menu::Backup;
require HSPC::CP::Menu::Crontab;
require HSPC::CP::Menu::DNS;
require HSPC::CP::Menu::FM;
require HSPC::CP::Menu::FTPAccount;
require HSPC::CP::Menu::Help;
require HSPC::CP::Menu::Mail;
require HSPC::CP::Menu::MailServer;
require HSPC::CP::Menu::MySQL;
require HSPC::CP::Menu::PHPMyAdmin;
require HSPC::CP::Menu::Person;
require HSPC::CP::Menu::ProFTPD;
require HSPC::CP::Menu::ResUsage;
require HSPC::CP::Menu::Server;
require HSPC::CP::Menu::Site;
require HSPC::CP::Menu::System;
require HSPC::CP::Menu::TS;
require HSPC::CP::Menu::UGM;
require HSPC::CP::Menu::Upgrade;
require HSPC::CP::Menu::VEServices;
require HSPC::CP::Menu::Website;

require HSPC::CP::Dash::Apache;
require HSPC::CP::Dash::Backup;
require HSPC::CP::Dash::Crontab;
require HSPC::CP::Dash::DNS;
require HSPC::CP::Dash::FM;
require HSPC::CP::Dash::Mail;
require HSPC::CP::Dash::ProFTPD;
require HSPC::CP::Dash::Server;
require HSPC::CP::Dash::Site;
require HSPC::CP::Dash::TS;
require HSPC::CP::Dash::Website;

## MT::VESrv modules
require HSPC::MT::VESrv::Apache;
require HSPC::MT::VESrv::Backup;
require HSPC::MT::VESrv::Crontab;
require HSPC::MT::VESrv::DebianServerCtrl;
require HSPC::MT::VESrv::FM;
require HSPC::MT::VESrv::FTPAccount;
require HSPC::MT::VESrv::FrontPage;
require HSPC::MT::VESrv::InetDTmplServerCtrl;
require HSPC::MT::VESrv::Mail::Access;
require HSPC::MT::VESrv::Mail::Action;
require HSPC::MT::VESrv::Mail::Info;
require HSPC::MT::VESrv::MySQL;
require HSPC::MT::VESrv::PHPMyAdmin;
require HSPC::MT::VESrv::ProFTPD;
require HSPC::MT::VESrv::SSL;
require HSPC::MT::VESrv::Sendmail;
require HSPC::MT::VESrv::SysVServerCtrl;
require HSPC::MT::VESrv::UGM;
require HSPC::MT::VESrv::XInetDServerCtrl;
##Support Manager
require HSPC::UM::TS::AbstractUI;
require HSPC::Core::CommentUI;
require HSPC::Core::UI;

## UP
require HSPC::MT::UP::Constants;
require HSPC::MT::UP::Proc;
require HSPC::MT::UP;
require HSPC::MT::UP::Setup;
require HSPC::MT::UP::MSG::Abstract;
require HSPC::MT::UP::MSG::Request;
require HSPC::MT::UP::MSG::Response;

## Billing Manager
require HSPC::MT::BM;

## Helper
require HSPC::MT::Core::Helper;
require HSPC::Core::Helper;

## XML API Gate and public API modules
require HSPC::XMLAPI;
require HSPC::API::Account;
require HSPC::API::Person;
require HSPC::API::Billing;
require HSPC::API::Config;
require HSPC::API::Domain;
require HSPC::API::HP;
require HSPC::API::Campaign;
require HSPC::API::PP;
require HSPC::API::Mailer;
require HSPC::API::Fraud;

## Payment Method plugin engine
require HSPC::MT::PM::Tools;

my $log = new HSPC::Logger;
## RMDEVEL start mark to remove in development mode
{ ## Load modules are not loaded already
	use Config;
	use File::Find;
	use HSPC::Util qw(sw_compare_versions);
	use HSPC::Config;

	my $process = sub {
		return unless /\.pm$/ && -f;
		(my $name = $File::Find::name) =~ s#^$Config{sitelib}/##g;
		require $name;
	};
	find($process, $Config{sitelib} . "/HSPC");

	my $libxmlver = `rpm -q libxml2`;
	$libxmlver =~ /libxml2-(\d+\.\d+\.\d+)/;
	$libxmlver = $1;
	if(sw_compare_versions($libxmlver, '2.6.16') == -1) {
		$CONFIG{PLESK_XSD_VALIDATE} = 0;
		$log->info("XSD validation of Plesk packets dissabled because of old libxml2");
	}

	my @mod = grep /^[AH]SPC/, keys %INC;
	$log->info("Started up. Total HSPc modules loaded: " . @mod);
}
## ENDRMDEVEL end mark to remove in development mode

## cleanup zombie mutexes.
HSPC::Mutex->cleanup_zombies();
HSPC::Mutex->reset_cleanup_time();

## init Billing core features
HSPC::MT::BM->core_init();

## init Payment Method plugin
HSPC::MT::PM::Tools->init();

unless (HSPC::Util::daemonize()) { ## Child?
	$log->info('Checking for updates ...');
	HSPC::MT::UP::Proc->check_for_updates(force => 1);
	CORE::exit(); ## That's all, guys!
}

} ## if (getpgrp(0) == $$)
} ## BEGIN

1;
